/************************************************************************/
/*									*/
/*	File Name: WRKSTAT.C			Created: 23-Jan-85	*/
/*									*/
/*----------------------------------------------------------------------*/
/*  Update & Modification Table:					*/
/*									*/
/*  Date	Action							*/
/*  ====	======							*/
/*									*/
/* 25-Jan-85	mods to 'tfonts' sizes. (Now 256 characters long)	*/
/*									*/
/* 01-May-85	convert to MSDOS					*/
/*									*/
/*----------------------------------------------------------------------*/
/*									*/
/*	Author:		Ian Houlding,					*/
/*			CISC Basingstoke,				*/
/*			Hampshire.					*/
/*									*/
/*	(c) Digital Equipment Co. Ltd. 1985				*/
/*									*/
/************************************************************************/
/************************************************************************
 *									*
 *	PRINT GRAPHICS WORK STATION SET-UP AND DEFAULT PARAMETERS	*
 *									*
 ************************************************************************/

#include <stdio.h>
#include <graph.h>

char ws_nam[6][15] = {
	"SMIDMON.GRA \n\n",
	"SHIGHMON.GRA\n\n",
	"SMIDCOL.GRA \n\n",
	"SHIGHCOL.GRA\n\n",
	"  DMID.GRA  \n\n",
	"  DHIGH.GRA \n\n"
	};

main(argc, argv)
int argc;
char *argv[];
{
  unsigned int i, j;
	   int k, s;

    if (argc == 1) {
	fprintf(stderr, "usage: wrkstat station_number [file_name]\n");
	exit(1);
    }
    k = atoi(argv[1]) % 7;
    if (k == -1) {
	if (openws(0, k, argv[2]) == EOF) exit(1);
	else printf("\n\033[5w     %s\033[2w\n", argv[2]);
    }
    else {
	if (openws(0, k) == EOF) exit(1);
	else printf("\n\033[5w     %s\033[2w\n", ws_nam[k - 1]);
    }

    printf("\033[1mWork station data:\t\t 00\033[0m\n");
    printf("reset.......");
    for(i = 0; i < 5; printf("%02x ", ws_data[i++]));
    printf("\n            ");
    for(; i < 9; printf("%02x ", ws_data[i++]));

    printf("\npitch.......");
    for(; i < 11; printf("%02x ", ws_data[i++]));

    printf("\nstart.......%02x ", ws_data[i++]);

    printf("\nzoom........");
    for(; i < 14; printf("%02x ", ws_data[i++]));

    printf("\nwdat........%02x", ws_data[i++]);

    printf("\npram........");
    for(; i < 20; printf("%02x ", ws_data[i++]));

    printf("\npram........");
    for(; i < 22; printf("%02x ", ws_data[i++]));

    printf("\ncchar.......%02x", ws_data[i++]);

    printf("\nvsync.......%02x", ws_data[i++]);

    printf("\nmode reg....%02x", ws_data[i++]);

    printf("\nspare.......");
    for(; i < 28; printf("%02x ", ws_data[i++]));

    s = i;


    printf("\n\n\033[1mp1 parameter table:\t\t%3x\033[0m\n            ", s);
    for(i = 0; i < 8; printf("%02x ", p1[i++]));
    printf("\n            ");
    for(; i < 16; printf("%02x ", p1[i++]));
    s += sizeof(p1);


    printf("\n\nws_type.....%02x\t\t\t\033[1m%3x\033[0m\n", ws_type, s);
    s += sizeof(ws_type);

    printf("ws_wmo......%02x\t\t\t\033[1m%3x\033[0m\n", ws_wmo, s);
    s += sizeof(ws_wmo);

    printf("gbmod.......%02x\t\t\t\033[1m%3x\033[0m\n", gbmod, s);
    s += sizeof(gbmod);

    printf("fgbg........%02x\t\t\t\033[1m%3x\033[0m\n", fgbg, s);
    s += sizeof(fgbg);

    printf("alups.......%02x\t\t\t\033[1m%3x\033[0m\n", alups, s);
    s += sizeof(alups);

    printf("gbmskl......%02x\t\t\t\033[1m%3x\033[0m\n", gbmskl, s);
    s += sizeof(gbmskl);
    printf("gbmskh......%02x\t\t\t\033[1m%3x\033[0m\n", gbmskh, s);
    s += sizeof(gbmskh);

    printf("gdcml.......%02x\t\t\t\033[1m%3x\033[0m\n", gdcml, s);
    s += sizeof(gdcml);
    printf("gdcmh.......%02x\t\t\t\033[1m%3x\033[0m\n", gdcmh, s);
    s += sizeof(gdcmh);

    printf("curl0.......%02x\t\t\t\033[1m%3x\033[0m\n", curl0, s);
    s += sizeof(curl0);
    printf("curl1.......%02x\t\t\t\033[1m%3x\033[0m\n", curl1, s);
    s += sizeof(curl1);
    printf("curl2.......%02x\t\t\t\033[1m%3x\033[0m\n", curl2, s);
    s += sizeof(curl2);

    printf("ymax........%04x (%d)\t\t\033[1m%3x\033[0m\n", ymax, ymax, s);
    s += sizeof(ymax);
    printf("xmax........%04x (%d)\t\t\033[1m%3x\033[0m\n", xmax, xmax, s);
    s += sizeof(xmax);

    printf("twdir.......%02x\t\t\t\033[1m%3x\033[0m\n", twdir, s);
    s += sizeof(twdir);

    nmritl = 0xff;
    nmrith = (HIRES) ? 0x7f : 0x3f;
    i = ((unsigned int)(nmrith << 8) + nmritl);
    printf("nmritl......%02x   (%d)\t\033[1m%3x\033[0m\n", nmritl, i, s);
    s += sizeof(nmritl);
    printf("nmrith......%02x\t\t\t\033[1m%3x\033[0m\n", nmrith, s);
    s += sizeof(nmrith);

    printf("sh_p_lin....%04x\t\t\033[1m%3x\033[0m\n", sh_p_lin, s);
    s += sizeof(sh_p_lin);
    printf("bytes_p_lin.%04x (%d)\t\t\033[1m%3x\033[0m\n", bytes_p_lin, bytes_p_lin, s);
    s += sizeof(bytes_p_lin);

    printf("x_start.....%04x (%d)\t\t\033[1m%3x\033[0m\n", x_start, x_start, s);
    s += sizeof(x_start);
    printf("y_start.....%04x (%d)\t\t\033[1m%3x\033[0m\n", y_start, y_start, s);
    s += sizeof(y_start);
    printf("x_stop......%04x (%d)\t\t\033[1m%3x\033[0m\n", x_stop, x_stop, s);
    s += sizeof(x_stop);
    printf("y_stop......%04x (%d)\t\t\033[1m%3x\033[0m\n", y_stop, y_stop, s);
    s += sizeof(y_stop);

    printf("g_strtx.....%04x (%d)\t\t\033[1m%3x\033[0m\n", g_strtx, g_strtx, s);
    s += sizeof(g_strtx);

    printf("scr_top.....%02x   (%d)\t\t\033[1m%3x\033[0m\n", scr_top, scr_top, s);
    s += sizeof(scr_top);
    printf("scr_bot.....%02x   (%d)\t\t\033[1m%3x\033[0m\n", scr_bot, scr_bot, s);
    s += sizeof(scr_bot);

    printf("\n\033[1mScroll table data:\t\t%3x-%3x\033[0m", s, (s + sizeof(scrltb) -1));
    s += sizeof(scrltb);

    printf("\n\n\033[1mColor map data:\t\t\t%3x\033[0m\n", s);
    printf("red_green...");
    for(i = 0; i < 16; printf("%02x ",clmpda.red_green[i++]));
    printf("\nmono_blue...");
    for(i = 0; i < 16; printf("%02x ",clmpda.mono_blue[i++]));
    s += 32;  /* sizeof(struct clmpda); */

    printf("\n\n\033[1mPattern table data:\t\t%3x\033[0m\n", s);
    printf("patterns....");
    for(i = 0; i < 16; printf("%02x ", pattbl[i++].patern));
    printf("\nmultipliers.");
    for(i = 0; i < 16; printf("%02x ", pattbl[i++].multiplier));
    s += 32;  /* (sizeof(struct pattbl) * 16); */

    printf("\n\nl_col.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", l_col, l_col, s);
    s += sizeof(l_col);
    printf("l_type......%02x   (%d)\t\t\033[1m%3x\033[0m\n", l_type, l_type, s);
    s += sizeof(l_type);
    printf("l_wid.......%02x   (%d)\t\t\033[1m%3x\033[0m\n\n", l_wid, l_wid, s);
    s += sizeof(l_wid);

    printf("f_col.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", f_col, f_col, s);
    s += sizeof(f_col);
    printf("f_type......%02x   (%d)\t\t\033[1m%3x\033[0m\n", f_type, f_type, s);
    s += sizeof(f_type);
    printf("f_style.....%02x   (%d)\t\t\033[1m%3x\033[0m\n", f_style, f_style, s);
    s += sizeof(f_style);

    printf("\n\033[1mFill style data:\t\t%3x\033[0m\n", s);
    printf("solid.......");
    for(i = 0; i < 8; printf("%02x ", f_patrn.solid[i++]));
    printf("\npattern.....");
    for(i = 0; i < 8; i++) {
	if (i) printf("\n            ");
	for(j = 0; j < 8; printf("%02x ", f_patrn.pattern[i][j++]));
    }
    printf("\nhatch.......");
    for(i = 0; i < 8; i++) {
	if (i) printf("\n            ");
	for(j = 0; j < 8; printf("%02x ", f_patrn.hatch[i][j++]));
    }
    s += 136; /* sizeof(struct f_patrn); */

    printf("\n\nt_col.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", t_col, t_col, s);
    s += sizeof(t_col);
    printf("t_font......%02x   (%d)\t\t\033[1m%3x\033[0m\n", t_font, t_font, s);
    s += sizeof(t_font);
    printf("t_sca.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", t_sca, t_sca, s);
    s += sizeof(t_sca);
    printf("t_dir.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", t_dir, t_dir, s);
    s += sizeof(t_dir);
    printf("t_x.........%04x (%d)\t\t\033[1m%3x\033[0m\n", t_x, t_x, s);
    s += sizeof(t_x);
    printf("t_y.........%04x (%d)\t\t\033[1m%3x\033[0m\n\n", t_y, t_y, s);
    s += sizeof(t_y);

    printf("m_col.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", m_col, m_col, s);
    s += sizeof(m_col);
    printf("m_type......%02x   (%d)\t\t\033[1m%3x\033[0m\n", m_type, m_type, s);
    s += sizeof(m_type);
    printf("m_sca.......%02x   (%d)\t\t\033[1m%3x\033[0m\n", m_sca, m_sca, s);
    s += sizeof(m_sca);

    printf("\n\033[1mMarker table data:\t\t%3x\033[0m\n", s);
    printf("mkr0........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr0[i++]));
    printf("\nmkr1........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr1[i++]));
    printf("\nmkr2........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr2[i++]));
    printf("\nmkr3........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr3[i++]));
    printf("\nmkr4........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr4[i++]));
    printf("\nmkr5........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr5[i++]));
    printf("\nmkr6........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr6[i++]));
    printf("\nmkr7........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr7[i++]));
    printf("\nmkr8........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr8[i++]));
    printf("\nmkr9........");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr9[i++]));
    printf("\nmkr10.......");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr10[i++]));
    printf("\nmkr11.......");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr11[i++]));
    printf("\nmkr12.......");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr12[i++]));
    printf("\nmkr13.......");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr13[i++]));
    printf("\nmkr14.......");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr14[i++]));
    printf("\nmkr15.......");
    for(i = 0; i < 16; printf("%03o ", m_tab.mkr15[i++]));
    s += 255; /* sizeof(struct m_tab); */

    printf("\n\n\033[1mLast Byte of structure at %3x\033[0m\033[0w\14", s);
    g_off();
}

